(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@vlemaitre/ngx-cvbsp-author-tool'), require('@angular/material/dialog'), require('@vlemaitre/ngx-cvbsp-uploader'), require('ngx-cvbsp-player'), require('@angular/common'), require('@angular/forms'), require('@vlemaitre/ngx-contenteditable'), require('@angular/material/button'), require('@angular/material/checkbox'), require('@angular/material/tooltip')) :
    typeof define === 'function' && define.amd ? define('ngx-player-video-create', ['exports', '@angular/core', '@vlemaitre/ngx-cvbsp-author-tool', '@angular/material/dialog', '@vlemaitre/ngx-cvbsp-uploader', 'ngx-cvbsp-player', '@angular/common', '@angular/forms', '@vlemaitre/ngx-contenteditable', '@angular/material/button', '@angular/material/checkbox', '@angular/material/tooltip'], factory) :
    (global = global || self, factory(global['ngx-player-video-create'] = {}, global.ng.core, global.ngxCvbspAuthorTool, global.ng.material.dialog, global.ngxCvbspUploader, global.ngxCvbspPlayer, global.ng.common, global.ng.forms, global.ngxContenteditable, global.ng.material.button, global.ng.material.checkbox, global.ng.material.tooltip));
}(this, (function (exports, core, ngxCvbspAuthorTool, dialog, ngxCvbspUploader, ngxCvbspPlayer, common, forms, ngxContenteditable, button, checkbox, tooltip) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var NgxPlayerVideoCreateService = /** @class */ (function () {
        function NgxPlayerVideoCreateService(authorToolService) {
            this.authorToolService = authorToolService;
            this.setTranslations();
        }
        NgxPlayerVideoCreateService.prototype.setTranslations = function () {
            this.authorToolService.translations.fr.NgxPlayerVideoComponent = 'Vidéo';
            this.authorToolService.translations.fr.REPLACE_VIDEO = 'Remplacer la vidéo';
            this.authorToolService.translations.fr.VIDEO_WIDTH = 'Largeur de la vidéo (% ou px)';
            this.authorToolService.translations.fr.VIDEO_HEIGHT = 'Hauteur de la vidéo (% ou px)';
            this.authorToolService.translations.fr.SHOW_INTRO = 'Montrer l\'introduction';
            this.authorToolService.translations.fr.NEXT_WHEN_FINISHED = 'Passer à la suite dès que la vidéo est terminée';
            this.authorToolService.translations.fr.AUTOPLAY = 'Lancer automatiquement la vidéo';
        };
        NgxPlayerVideoCreateService.ctorParameters = function () { return [
            { type: ngxCvbspAuthorTool.NgxCvbspAuthorToolService }
        ]; };
        NgxPlayerVideoCreateService.ɵprov = core.ɵɵdefineInjectable({ factory: function NgxPlayerVideoCreateService_Factory() { return new NgxPlayerVideoCreateService(core.ɵɵinject(ngxCvbspAuthorTool.NgxCvbspAuthorToolService)); }, token: NgxPlayerVideoCreateService, providedIn: "root" });
        NgxPlayerVideoCreateService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __metadata("design:paramtypes", [ngxCvbspAuthorTool.NgxCvbspAuthorToolService])
        ], NgxPlayerVideoCreateService);
        return NgxPlayerVideoCreateService;
    }());

    var NgxPlayerVideoCreateComponent = /** @class */ (function () {
        function NgxPlayerVideoCreateComponent(service, dialog) {
            var _this = this;
            this.service = service;
            this.dialog = dialog;
            this.changeEvent = new core.EventEmitter();
            this.onUploaded = function (result) {
                if (result) {
                    _this.data.videoUrls[_this.lang] = result.externalUrl;
                    _this.data.videoTypes[_this.lang] = 'video/mp4';
                    _this.changeEvent.next(_this.data);
                }
            };
        }
        NgxPlayerVideoCreateComponent.prototype.ngOnInit = function () {
            this.data.intro = this.data.intro ? this.data.intro : { keep: null, fr: 'Votre intro', en: 'This is your intro' };
            this.data.title = this.data.title ? this.data.title : { keep: null, fr: 'Titre', en: 'Title' };
            this.data.videoHeights = this.data.videoHeights ? this.data.videoHeights : { keep: null, fr: '', en: '240' };
            this.data.videoTypes = this.data.videoTypes ? this.data.videoTypes : new ngxCvbspPlayer.Multilang();
            this.data.videoWidths = this.data.videoWidths ? this.data.videoWidths : { keep: null, fr: '100%', en: '100%' };
            this.data.videoUrls = this.data.videoUrls ? this.data.videoUrls : new ngxCvbspPlayer.Multilang();
        };
        NgxPlayerVideoCreateComponent.prototype.inputChange = function () {
            this.changeEvent.next(this.data);
        };
        NgxPlayerVideoCreateComponent.prototype.openUploaderDialog = function (replace) {
            if (!this.service.urlToUpload) {
                alert('you need to add an url to upload video in the config of the module, check the readme');
                return;
            }
            var dialogRef = this.dialog.open(ngxCvbspUploader.NgxCvbspUploaderDialogComponent, {
                width: '500px',
                data: {
                    restrictedExtensions: ['mp4'],
                    closeOnUpload: true,
                    urlToUpload: this.service.urlToUpload
                },
            });
            dialogRef.afterClosed().subscribe(this.onUploaded);
        };
        NgxPlayerVideoCreateComponent.ctorParameters = function () { return [
            { type: NgxPlayerVideoCreateService },
            { type: dialog.MatDialog }
        ]; };
        NgxPlayerVideoCreateComponent = __decorate([
            core.Component({
                // tslint:disable-next-line:component-selector
                selector: 'ngx-player-video-create',
                template: "<div class=\"cvbsp-video-container\" *ngIf=\"data\">\n  <div class=\"no-video\" *ngIf=\"!data.videoUrls[lang]\">     \n    <ngx-cvbsp-uploader \n      [restrictedExtensions]=\"['mp4']\"\n      [urlToUpload]=\"service.urlToUpload\"\n      (itemUploadedEvent)=\"onUploaded($event)\" \n      ></ngx-cvbsp-uploader>\n  </div>\n  <video *ngIf=\"data.videoUrls[lang]\" id=\"video\" #videoPlayer controls=\"controls\" preload=\"metadata\"\n  webkit-playsinline=\"webkit-playsinline\" class=\"video-player\">\n    <source \n    [src]=\"data.videoUrls[lang]\" \n    [type]=\"data.videoTypes[lang]\" />\n  </video>\n  <br/>\n  <button *ngIf=\"data.videoUrls[lang]\" mat-button (click)=\"openUploaderDialog(true)\">\n    {{ 'REPLACE_VIDEO' | translate }}\n  </button>\n  <br/><br/>\n  <div [contenteditable]=\"true\" (change)=\"inputChange()\" [(ngModel)]=\"data.title[lang]\" class=\"cvbsp-video-title\" *ngIf=\"data.hideTitle !== true\">\n  </div><br/>\n  \n  <html-box [(html)]=\"data.intro[lang]\"  *ngIf=\"data?.showIntro\"\n          [placeholder]=\"'CLICK_TO_EDIT' | translate\"></html-box>\n</div>\n<br/>\n<a class=\"adv-params-link\" (click)=\"showAdvancedParameters = !showAdvancedParameters\">\n  <span>{{ (showAdvancedParameters ? 'HIDE_ADVANCED_PARAMETERS' : 'SHOW_ADVANCED_PARAMETERS') | translate }} </span>\n</a>\n<br/><br/>\n<div *ngIf=\"showAdvancedParameters\" class=\"adv-params\">\n  <mat-checkbox  [(ngModel)]=\"data.autoplay\">\n    {{ 'AUTOPLAY' | translate }}\n  </mat-checkbox><br/>\n  <mat-checkbox  [(ngModel)]=\"data.nextWhenFinished\">\n    {{ 'NEXT_WHEN_FINISHED' | translate }}\n  </mat-checkbox><br/>\n  {{ 'VIDEO_WIDTH' | translate }} :\n  <input class=\"input-title\" \n    name=\"width-text\"\n    (change)=\"inputChange()\" \n    [(ngModel)]=\"data.videoWidths[lang]\">\n  <br/>\n  {{ 'VIDEO_HEIGHT' | translate }} :\n  <input class=\"input-title\" \n    name=\"width-text\"\n    (change)=\"inputChange()\" \n    [(ngModel)]=\"data.videoHeights[lang]\">\n    <br/><br/>\n  <mat-checkbox  [(ngModel)]=\"data.hideTitle\">\n    {{ 'HIDE_TITLE' | translate }}\n  </mat-checkbox><br/>\n  <mat-checkbox  [(ngModel)]=\"data.showIntro\" >\n    {{ 'SHOW_INTRO' | translate }}\n  </mat-checkbox><br/>\n  <div  class=\"block-box\" >\n    <mat-checkbox \n    [indeterminate]=\"data.noNext === null || data.noNext === undefined\" \n    class=\"checkbox-header\" [(ngModel)]=\"data.noNext\" \n    [matTooltip]=\"'NO_NEXT_TP' | translate\">\n      {{ 'NO_NEXT' | translate }}\n    </mat-checkbox>\n    <br/>\n    <input class=\"input-title\" \n    *ngIf=\"!data.noNext\"\n    name=\"next-text\"\n    placeholder=\"{{ 'NEXT_LABEL' | translate }}\"\n    (change)=\"inputChange()\" \n    [(ngModel)]=\"data.nextLabel[lang]\">\n  </div>\n  <div  class=\"block-box\" >\n      <mat-checkbox \n      [indeterminate]=\"data.noBack === null || data.noBack === undefined\" \n      class=\"checkbox-header\" [(ngModel)]=\"data.noBack\" \n      [matTooltip]=\"'NO_BACK_TP' | translate\">\n        {{ 'NO_BACK' | translate }}\n      </mat-checkbox><br/>\n      <input *ngIf=\"!data.noBack\"\n      class=\"input-title\" \n      placeholder=\"{{ 'BACK_LABEL' | translate }}\"\n      name=\"back-text\"\n      (change)=\"inputChange()\" \n      [(ngModel)]=\"data.backLabel[lang]\">\n  </div> \n  <div  class=\"block-box\" >\n</div> \n</div>\n",
                styles: ["video{outline:0}.cvbsp-video-container{text-align:center}.cvbsp-video-title{font-size:20px;color:#888}.back-btn{float:left}.cvbsp-video-actions{position:absolute;width:100%;padding:5px;bottom:0}.cvbsp-video-intro{padding:10px}.no-video{display:inline-block}.input-size{border:none;width:30px;height:40px;outline:0}.input-title{border:none;width:200px;height:40px;outline:0}.adv-params-link{font-weight:700;cursor:pointer}"]
            }),
            __metadata("design:paramtypes", [NgxPlayerVideoCreateService,
                dialog.MatDialog])
        ], NgxPlayerVideoCreateComponent);
        return NgxPlayerVideoCreateComponent;
    }());

    var NgxPlayerVideoCreateModule = /** @class */ (function () {
        function NgxPlayerVideoCreateModule() {
        }
        NgxPlayerVideoCreateModule = __decorate([
            core.NgModule({
                declarations: [NgxPlayerVideoCreateComponent],
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    ngxCvbspPlayer.NgxCvbspPlayerModule,
                    ngxCvbspAuthorTool.NgxCvbspAuthorToolModule,
                    ngxContenteditable.NgxContenteditableModule,
                    ngxCvbspUploader.NgxCvbspUploaderModule,
                    button.MatButtonModule,
                    checkbox.MatCheckboxModule,
                    tooltip.MatTooltipModule
                ],
                exports: [NgxPlayerVideoCreateComponent],
                entryComponents: [NgxPlayerVideoCreateComponent]
            })
        ], NgxPlayerVideoCreateModule);
        return NgxPlayerVideoCreateModule;
    }());

    exports.NgxPlayerVideoCreateComponent = NgxPlayerVideoCreateComponent;
    exports.NgxPlayerVideoCreateModule = NgxPlayerVideoCreateModule;
    exports.NgxPlayerVideoCreateService = NgxPlayerVideoCreateService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-player-video-create.umd.js.map
