import { OnInit, EventEmitter } from '@angular/core';
import { IEditContentComponent } from '@vlemaitre/ngx-cvbsp-author-tool';
import { NgxPlayerVideoData } from '@vlemaitre/ngx-player-video';
import { MatDialog } from '@angular/material/dialog';
import { NgxPlayerVideoCreateService } from '../ngx-player-video-create.service';
export declare class NgxPlayerVideoCreateComponent implements OnInit, IEditContentComponent {
    service: NgxPlayerVideoCreateService;
    private dialog;
    lang: string;
    langApp: string;
    data: NgxPlayerVideoData;
    changeEvent: EventEmitter<NgxPlayerVideoData>;
    showAdvancedParameters: boolean;
    constructor(service: NgxPlayerVideoCreateService, dialog: MatDialog);
    ngOnInit(): void;
    inputChange(): void;
    openUploaderDialog(replace?: boolean): void;
    onUploaded: (result: any) => void;
}
